%define device_mapper_version 1.02.39-1.el5_5.1

Summary: Cluster extensions for userland logical volume management tools 
Name: lvm2-cluster
Version: 2.02.56
Release: 7%{?dist}.4
License: GPL
Group: System Environment/Base
URL: http://sources.redhat.com/lvm2
Source0: LVM2.%{version}.tgz
Patch0: lvm2-rhel5.patch
Patch1: cluster-locking-built-in.patch
Patch2: lvm2-2_02_57-fix-tools.patch
Patch3: lvm2-2_02_57-fix-clvmd-leak.patch
Patch4: lvm2-2_02_57-fix-mirror-repair.patch
Patch5: lvm2-2_02_57-fix-cluster-locking.patch
Patch6: lvm2-2_02_57-fix-vg-leaks.patch
Patch7: lvm2-2_02_57-fix-missing-flag.patch
Patch8: lvm2-2_02_57-fix-precommitted-metadata.patch
Patch9: lvm2-2_02_57-fix-filter-stack-overflow.patch
Patch10: lvm2-2_02_57-fix-fail-repair.patch
Patch11: lvm2-2_02_57-fix-vgremove-missing.patch
Patch12: lvm2-2_02_59-fix-clvmd-suspended.patch
Patch13: lvm2-2_02_60-fix-pvmove-abort.patch
Patch14: lvm2-2_02_60-fix-clvmd-v.patch
Patch15: lvm2-2_02_61-fix-core-log-resync.patch
Patch16: lvm2-2_02_61-fix-repair-no-action.patch
Patch17: lvm2-2_02_63-fix-clvmd-thread-race.patch
Patch18: lvm2-2_02_63-fix-symlink-remove.patch
Patch19: lvm2-2_02_63-fix-device-rescans.patch
Patch20: lvm2-2_02_65-fix-vgscan.patch
Patch21: lvm2-cluster-cve-2010-2526.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: device-mapper >= %{device_mapper_version}
BuildRequires: libselinux-devel >= 1.30.19-4
BuildRequires: libsepol-devel
BuildRequires: libtermcap-devel
BuildRequires: ncurses-devel
BuildRequires: readline-devel
BuildRequires: cman-devel
Requires: lvm2 >= %{version}-8.el5_5.6
Requires: mkinitrd >= 4.2.1.3-1
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): device-mapper >= %{device_mapper_version}
Requires(preun): lvm2 >= 2.02

%define _exec_prefix /usr

%description
Extensions to LVM2 to support clusters.

%prep
%setup -q -n LVM2.%{version}
%patch0 -p1 -b .rhel5
%patch1 -p1 -b .locking
%patch2 -p1 -b .tools
%patch3 -p1 -b .leak
%patch4 -p1 -b .mrepair
%patch5 -p1 -b .clocking
%patch6 -p1 -b .vgleaks
%patch7 -p1 -b .missing
%patch8 -p1 -b .precommit
%patch9 -p1 -b .stack
%patch10 -p1 -b .return
%patch11 -p1 -b .missing
%patch12 -p1 -b .suspend
%patch13 -p1 -b .abort
%patch14 -p1 -b .v
%patch15 -p1 -b .resync
%patch16 -p1 -b .noaction
%patch17 -p1 -b .race
%patch18 -p1 -b .symlink
%patch19 -p1 -b .rescan
%patch20 -p1 -b .vgscan
%patch21 -p1 -b .cve-2010-2526

%build
%configure --enable-static_link --disable-readline --enable-lvm1_fallback --with-clvmd=cman --with-cluster=internal --with-pool=internal --with-staticdir=/sbin --with-user= --with-group= --enable-dmeventd --enable-cmdlib --with-device-uid=0 --with-device-gid=6 --with-device-mode=0660 --enable-pkgconfig --enable-units-compat

make DESTDIR=$RPM_BUILD_ROOT

%install
rm -rf $RPM_BUILD_ROOT
make install_cluster DESTDIR=$RPM_BUILD_ROOT

mkdir -p -m755 $RPM_BUILD_ROOT/etc/rc.d/init.d
install scripts/clvmd_init_red_hat $RPM_BUILD_ROOT/etc/rc.d/init.d/clvmd
install -m 0755 scripts/lvmconf.sh $RPM_BUILD_ROOT/usr/sbin/lvmconf

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add clvmd

if [ "$1" -gt "1" ] ; then
	/sbin/service clvmd force-try-restart >/dev/null 2>&1 || :
fi

%preun
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del clvmd
	/usr/sbin/lvmconf --disable-cluster
fi

%files
%defattr(-,root,root,-)
%attr(755,root,root) %{_sbindir}/clvmd
%{_sbindir}/lvmconf
%{_mandir}/man8/clvmd.8.gz
/etc/rc.d/init.d/clvmd

%changelog
* Mon Jul 19 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-el5_5.4
- CVE-2010-2526: Fix insecurity when communicating between lvm2 and clvmd.
  Resolves: #616044

* Fri May 14 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-el5_5.3
- Fix vgscan to refresh device cache if cluster locking is used.
  Resolves: #592220

* Wed May 12 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-7.el5_5.2
- Fix init info in clvmd initscript to fix shutdown sequence.
  Resolves: #591524

* Thu Apr 22 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-7.el5_5.1
- Fix incorrect removal of symlinks after LV deactivation fails.
- Only do one full device scan during each read of text format metadata.
- Fix thread race in clvmd.
  Related: #580831 #584705 #583995
  Resolves: #584706

* Mon Feb 8 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-7
- Make mirror repair exit with success when no action is needed.
- Fix inappropriate second resync when adding mimage to core-logged mirror.
  Related: #528208 #562004 #510526

* Wed Jan 27 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-6
- Fix pvmove abort to be cluster-aware when temporary mirror activation fails.
  Resolves: #538571

* Wed Jan 20 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-5
- Fix mirror repair allocate policy fallback to remove.
  Resolves: #552723 #548223 #538571

* Wed Jan 6 2010 Milan Broz <mbroz@redhat.com> - 2.02.56-4
- Fix precommitted metadata cache handling on remote nodes.
- Fix mirror repair policies and automatic missing PV removal.
- Fix possible stack overflow in persistent filter dump.
  Resolves: #538571 #538620 #547891 #547842 #552723

* Fri Dec 18 2009 Milan Broz <mbroz@redhat.com> - 2.02.56-3
- Fix missing flag device handling.
  Resolves: #537954 #543225

* Thu Dec 10 2009 Milan Broz <mbroz@redhat.com> - 2.02.56-2
- Fix problems with mirror repair handling.
- Fix cluster locking flags.
  Related: #536817
  Resolves: #543146

* Tue Nov 24 2009 Milan Broz <mbroz@redhat.com> - 2.02.56-1
- Fix problems with clustered volumes handling.
  Resolves: #538515 #539670

* Fri Nov 20 2009 Milan Broz <mbroz@redhat.com> - 2.02.55-1
- Update to latest upstream release, all fixes and enhancements
  detailed in WHATS_NEW file.
  Related: #536817

* Thu Nov 12 2009 Milan Broz <mbroz@redhat.com> - 2.02.54-1
- Update to latest upstream release, all fixes and enhancements
  detailed in WHATS_NEW file.
  Resolves: #536817 #528208 #517900

* Fri Aug 18 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-10
- Fix default device mode permissions when using static lvm.
  Resolves: #524058

* Thu Aug 13 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-9
- Add write lock write prioritization to avoid possible starvation.
- Fix orphan order locking (fix vgextend to use blocking lock).
- Use read lock for lvchange activation commands.
  Resolves: #515232 #516773

* Thu Jun 18 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-8
- Fix various memory leaks in command context manipulation
  Related: #504877

* Thu Jun 11 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-6
- Fix partial activation and lvconvert --repair on clusters.
  Resolves: #505141
  Related:  #505143

* Fri Jun 05 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-5
- Fix problems when repairing inconsistent metadata.
  Related: #504312

* Thu Jun 04 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-4
- Fix virtual origin snapshot manipulation.
- Implement mirror repair policies.
  Related: #249478 #503708

* Mon Jun 01 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-3
- Fix crash when calculating readahead on missing device in vgreduce.
- Fix mirror log allocation when smallest PV has only 1 extent.
  Related: #502899 #502671

* Wed May 20 2009 Milan Broz <mbroz@redhat.com> - 2.02.46-1
- Update to latest upstream release.
  Resolves: #501756 #480145 #488219 #488728

* Wed Nov 26 2008 Milan Broz <mbroz@redhat.com> - 2.02.40-7
- Fix startup race in clvmd.
  Resolves: #470417

* Fri Oct 24 2008 Milan Broz <mbroz@redhat.com> - 2.02.40-6
- Avoid overwriting in-use on-disk text metadata.
- Fix mirror upconvert for active mirrors.
  Resolves: #467435 #455670

* Mon Oct 06 2008 Milan Broz <mbroz@redhat.com> - 2.02.40-4
- Fix excessive alignment for MD devices.
  Resolves: #463431

* Thu Sep 25 2008 Milan Broz <mbroz@redhat.com> - 2.02.40-3
- Fix mirror down convert and partial VG handling.
  Resolves: #463520

* Fri Sep 19 2008 Milan Broz <mbroz@redhat.com> - 2.02.40-2
- Do not print warning for old stripe_filler default setting.

* Fri Sep 19 2008 Milan Broz <mbroz@redhat.com> - 2.02.40-1
- Update to latest upstream release.
  Resolves: #456731

* Wed Jul 02 2008 Milan Broz <mbroz@redhat.com> - 2.02.39-1
- Update to latest upstream release.
  Resolves: #439384 #251940 #448059
  Related:  #452813

* Wed Apr 02 2008 Milan Broz <mbroz@redhat.com> - 2.02.32-4
- Fix another allocation bug with clvmd and large node IDs.
  Resolves: #438434

* Tue Mar 25 2008 Milan Broz <mbroz@redhat.com> - 2.02.32-3
- clvmd no longer crashes if it sees nodeids over 50.
- Fix potential deadlock in clvmd thread handling.
  Resolves: #437446 #438434

* Tue Mar 04 2008 Milan Broz <mbroz@redhat.com> - 2.02.32-2
- Fix several lvconvert bugs.
  Resolves: #433955

* Tue Jan 29 2008 Milan Broz <mbroz@redhat.com> - 2.02.32-1
- Fix internal metadata corruption in lvchange --resync.
  Resolves: #430540

* Mon Jan 21 2008 Milan Broz <mbroz@redhat.com> - 2.02.31-1
- Fix --nosync mirror creation.
  Resolves: #429342

* Thu Jan 17 2008 Milan Broz <mbroz@redhat.com> - 2.02.30-1
- Update to latest upstream release.
  Resolves: #423661

* Mon Jun 18 2007 Milan Broz <mbroz@redhat.com> - 2.02.26-1
- Update to latest upstream release.
  Resolves: #232436 #237386

* Sun Dec 17 2006 Alasdair Kergon <agk@redhat.com> - 2.02.16-3
- Fix clvmd deadlock.
  Resolves: #217753

* Fri Dec 01 2006 Alasdair Kergon <agk@redhat.com> - 2.02.16-2
- Adjust some alignments for ia64. 
- Fix VG clustered read locks to use PR not CR. 
- Add startup timeout to clvmd startup script.

* Tue Nov 21 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-3
- Fix clvmd init script line truncation.

* Tue Nov 21 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-2
- Fix lvm.conf segfault.

* Mon Nov 20 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-1
- Roll in recent fixes.
  Resolves: #214604

* Fri Nov 03 2006 Alasdair Kergon <agk@redhat.com> - 2.02.12-7
- Fix last fix.

* Fri Nov 03 2006 Alasdair Kergon <agk@redhat.com> - 2.02.12-6
- Fix userspace mirror log wiping.
  Resolves: #213797

* Thu Oct 26 2006 Alasdair Kergon <agk@redhat.com> - 2.02.12-5
- Fix pvdisplay and pvmove to cope if old PV is found claiming to have size 0.
  Resolves: #211675

* Mon Oct 23 2006 Alasdair Kergon <agk@redhat.com> - 2.02.12-4
- Make spec file closer to lvm2.spec for easier maintenance.
- Use the built-in cluster support (locking_type 3) by default,
  replacing the shared library, removing ldconfig and updating
  the lvmconf script.

* Mon Oct 16 2006 Alasdair Kergon <agk@redhat.com> - 2.02.12-1.0
- Change package suffix to use dist variable.
- Fall back to internal locking if external locking lib is missing or fails.

* Fri Oct 13 2006 Alasdair Kergon <agk@redhat.com> - 2.02.11-1.0
- lvmconf --enable-cluster no longer requires locking library post-installation
- clvmd accepts -R to instruct a running daemon to reload its internal cache
- Remote error messages are transmitted back across the cluster.
- Fix bug that caused clvmd to die if node with a long name crashed.
- Fix vgsplit to retain clustered VG attribute.

* Tue Sep 19 2006 Alasdair Kergon <agk@redhat.com> - 2.02.10-2.0
- No longer enable cluster by default.

* Tue Sep 19 2006 Alasdair Kergon <agk@redhat.com> - 2.02.10-1.0
- New upstream.
- Removed no_optimized_deactive patch.

* Thu Aug 31 2006 Alasdair Kergon <agk@redhat.com> - 2.02.09-1.1
- Build all archs.

* Thu Aug 17 2006 Alasdair Kergon <agk@redhat.com> - 2.02.09-1.0
- Upstream update for 64KB page size support.

* Tue Aug 15 2006 Alasdair Kergon <agk@redhat.com> - 2.02.08-1.0
- Create RHEL5 branch.
- Only build cman.
- Fix spec file dependencies.

* Mon Jul 24 2006 Chris Feist <cfeist@redhat.com> - 2.02.06-7.0
- Rebuilt with no_optimized_deactive patch.

* Mon Jul 17 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-6.0
- Rebuild with fix to last patch.

* Tue Jul 11 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-5.0
- Rebuild after recent lvm2 patches.

* Tue Jul 04 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-4.0
- Avoid clvm 'unaligned access' error on some archs. (194626, lost)
- Rebuild after recent lvm2 patches.

* Wed May 24 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-1.0
- Update to 2.02.06.
- BuildRequires libsepol-devel.
- Tidy spec file. [192100]

* Wed Mar 8 2006 Alasdair Kergon <agk@redhat.com> - 2.02.02-2.0
- Add missing chkconfig prereq.

* Fri Feb 10 2006 Alasdair Kergon <agk@redhat.com> - 2.02.02-1.0
- New upstream release.

* Thu Jan 12 2006 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.2
- Rebuild against latest libdevmapper.

* Wed Jan 04 2006 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.1
- Rebuild against latest libdevmapper.

* Mon Dec 05 2005 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.0
- Update to latest upstream release.

* Tue Aug 16 2005 Alasdair Kergon <agk@redhat.com> - 2.01.14-1.0
- Incorporate additional upstream fixes since June.

* Tue Aug 16 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-6.0
- Add mkinitrd dependency to ensure it gets upgraded first. [165255]

* Tue Jun 14 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-5.0
- Couple of fixes to clvmd file descriptor closing.
- Fix potential spin loop in clvmd.

* Fri Jun 10 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-4.0
- Automatically enable clustering in lvm.conf on installation.

* Tue Jun 07 2005 Chris Feist <cfeist@redhat.com> - 2.01.09-3.1
- Rebuild against libgulm.so.1.0.0 (instead of libgulm.so.1.0).

* Tue May 17 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-3.0
- Fix clvmd init script.

* Thu Apr 21 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-2.1
- BuildRequires: dlm-devel, gulm-devel, ccs-devel

* Wed Apr 13 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-2.0
- Improve co-operation between clvmd and gulm over node state changes. [146056]

* Mon Apr 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-1.1
- Switch from 'ExcludeArch: s390 s390x ppc' to 
  'ExclusiveArch: i386 ia64 x86_64' to match dlm dependency.

* Mon Apr 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-1.0
- clvmd: Don't allow user operations to start until lvm thread is fully up.
- clvmd-gulm: Set KEEPALIVE on sockets.

* Tue Mar 22 2005 Alasdair Kergon <agk@redhat.com> - 2.01.08-1.0
- Improve detection of external changes affecting internal cache.

* Thu Mar 10 2005 Alasdair Kergon <agk@redhat.com> - 2.01.07-2.0
- clvmd lvm_thread_lock fix.

* Tue Mar 08 2005 Alasdair Kergon <agk@redhat.com> - 2.01.07-1.0
- clvmd FDs close-on-exec
- unlock gulm VG & orphan locks at startup in case they are stale
- unlock gulm VG & orphan locks if client dies.

* Fri Mar 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.06-1.1
- Extra /dev scanning required for clustered operation.

* Thu Mar 03 2005 Alasdair Kergon <agk@redhat.com> - 2.01.06-1.0
- More clvmd gulm fixes.

* Wed Feb 09 2005 Alasdair Kergon <agk@redhat.com> - 2.01.04-1.0
- Some more clvmd fixes.

* Mon Feb 07 2005 Chris Feist <cfeist@redhat.com> - 2.01.03-2.0
- Added chkconfig --add & --del to start init scripts.

* Tue Feb 01 2005 Alasdair Kergon <agk@redhat.com> - 2.01.03-1.0
- clvmd startup mesgs improved; avoid gulm hang after node reboot

* Fri Jan 21 2005 Alasdair Kergon <agk@redhat.com> - 2.01.02-1.0
- clvmd startup fix; recognise gnbd; improve error reporting.

* Thu Jan 20 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.2
- Install the correct clvmd init script.

* Wed Jan 19 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.1
- Fix spec file for 2.01.

* Wed Jan 19 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.0
- Fix clvmd build & update vgcreate man page.

* Mon Jan 17 2005 Alasdair Kergon <agk@redhat.com> - 2.01.00-1.0
- Include cman & gulm in same library.
- Remove cluster subdir.

* Thu Dec 23 2004 Chris Feist <cfeist@redhat.com> - 2.00.32-1.0
- New upstream sources.

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com> - 2.00.29-1.11
- Added init script for clvm.

* Wed Dec 15 2004 Chris Feist <cfeist@redhat.com> - 2.00.29-1.11
- Use %{_libdir} which fixes 64 bit architecture build problems.

* Wed Dec 1 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.2
- Remove superfluous Requires.

* Tue Nov 30 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.1
- Sort out most of the files.

* Tue Nov 30 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.0
- Initial import.
